#| repl.jl -- rep input loop

   $Id: repl.jl,v 1.39 2001/01/08 21:49:11 jsh Exp $

   Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

   This file is part of librep.

   librep is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   librep is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with librep; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|#

(define-structure rep.util.repl

    (export repl
	    make-repl
	    repl-struct
	    repl-pending
	    repl-iterate
	    repl-completions)

    (open rep
	  rep.structures
	  rep.system
	  rep.regexp
	  rep.io.readline)

  (define current-repl (make-fluid))

  (define (make-repl #!optional initial-struct)
    (cons (or initial-struct *user-structure*) nil))

  (define repl-struct car)
  (define repl-pending cdr)
  (define repl-set-struct rplaca)
  (define repl-set-pending rplacd)

  (define (repl-eval form)
    (eval form (intern-structure (repl-struct (fluid current-repl)))))

  (define (repl-iterate repl input)
    (setq input (concat (repl-pending repl) input))
    (repl-set-pending repl nil)
    (let-fluids ((current-repl repl))
      (let ((print-escape t))
	(catch 'return
	  (condition-case data
	      (progn
		(if (string-looking-at "\\s*,\\s*" input)
		    ;; a `,' introduces a meta command
		    (let ((stream (make-string-input-stream input (match-end)))
			  (sexps '()))
		      (condition-case nil
			  (while t
			    (setq sexps (cons (read stream) sexps)))
			(end-of-stream (setq sexps (nreverse sexps))))
		      (if (get (car sexps) 'repl-command)
			  (apply (get (car sexps) 'repl-command) (cdr sexps))
			(format standard-output
				"unrecognized command name: %s\n"
				(car sexps))))
		  (let ((form (condition-case nil
				  (read-from-string input)
				(premature-end-of-stream
				 (repl-set-pending repl input)
				 (throw 'return
					(and input
					     (not (string= "" input))))))))
		    (format standard-output "%S\n" (repl-eval form))))
		t)
	    (error
	     (error-handler (car data) (cdr data))))))))

  (define (repl #!optional initial-structure)
    ;; returns t if repl should run again
    (define (run-repl)
      (let ((input (readline
		    (format nil (if (repl-pending (fluid current-repl))
				    "" "%s> ")
			    (repl-struct (fluid current-repl)))
		    completion-generator)))
	(and input (repl-iterate (fluid current-repl) input))))
    (define (interrupt-handler data)
      (if (eq (car data) 'user-interrupt)
	  (progn
	    (format standard-output "User interrupt!\n")
	    t)
	(raise-exception data)))
    (let-fluids ((current-repl (make-repl initial-structure)))
      (write standard-output "\nEnter `,help' to list commands.\n")
      (let loop ()
	(when (call-with-exception-handler run-repl interrupt-handler)
	  (loop)))))

  (define (print-list data #!optional map)
    (unless map (setq map identity))
    (let* ((count (length data))
	   (mid (inexact->exact (ceiling (/ count 2)))))
      (do ((i 0 (1+ i))
	   (left data (cdr left))
	   (right (nthcdr mid data) (cdr right)))
	  ((null left))
	(when (< i mid)
	  (format standard-output "  %-30s"
		  (format nil "%s" (map (car left))))
	  (when right
	    (format standard-output " %s" (map (car right))))
	  (write standard-output #\newline)))))

  (define (completion-generator w)
    (apropos (concat #\^ (quote-regexp w))
	     (lambda (x)
	       (condition-case nil
		   (progn
		     (repl-eval x)
		     t)
		 (void-value nil)))))

  (define (repl-completions repl word)
    (let-fluids ((current-repl repl))
      (completion-generator word)))

  (define (error-handler err data)
    (write standard-error
	   (format nil "\^G*** %s: %s\n"
		   (or (get err 'error-message) err)
		   (mapconcat (lambda (x)
				(format nil "%s" x)) data ", "))))


;;; module utils

  (define (module-exports-p name var)
    (structure-exports-p (get-structure name) var))

  (define (module-imports name)
     (structure-imports (get-structure name)))

  (define (locate-binding* name)
    (or (locate-binding name (append (list (repl-struct (fluid current-repl)))
				     (module-imports
				      (repl-struct (fluid current-repl)))))
	(and (structure-bound-p
	      (get-structure (repl-struct (fluid current-repl))) name)
	     (repl-struct (fluid current-repl)))))


;;; commands

  (put 'in 'repl-command
       (lambda (struct #!optional form)
	 (if form
	     (format standard-output "%S\n"
		     (eval form (get-structure struct)))
	   (repl-set-struct (fluid current-repl) struct))))
  (put 'in 'repl-help "STRUCT [FORM ...]")

  (put 'load 'repl-command
       (lambda structs
	 (mapc (lambda (struct)
		 (intern-structure struct)) structs)))
  (put 'load 'repl-help "STRUCT ...")

  (put 'reload 'repl-command
       (lambda structs
	 (mapc (lambda (struct)
		 (name-structure (get-structure struct) nil)
		 (intern-structure struct)) structs)))
  (put 'reload 'repl-help "STRUCT ...")

  (put 'unload 'repl-command
       (lambda structs
	 (mapc (lambda (struct)
		 (name-structure (get-structure struct) nil)) structs)))
  (put 'unload 'repl-help "STRUCT ...")

  (put 'load-file 'repl-command
       (lambda files
	 (mapc (lambda (f)
		 (repl-eval `(,load ,f))) files)))
  (put 'load-file 'repl-help "\"FILENAME\" ...")

  (put 'open 'repl-command
       (lambda structs
	 (repl-eval `(,open-structures (,quote ,structs)))))
  (put 'open 'repl-help "STRUCT ...")

  (put 'access 'repl-command
       (lambda structs
	 (repl-eval `(,access-structures (,quote ,structs)))))
  (put 'access 'repl-help "STRUCT ...")

  (put 'structures 'repl-command
       (lambda ()
	 (let (structures)
	   (structure-walk (lambda (var value)
			     (setq structures (cons var structures)))
			   (get-structure '%structures))
	   (print-list (sort structures)))))

  (put 'interfaces 'repl-command
       (lambda ()
	 (let (interfaces)
	   (structure-walk (lambda (var value)
			     (setq interfaces (cons var interfaces)))
			   (get-structure '%interfaces))
	   (print-list (sort interfaces)))))

  (put 'bindings 'repl-command
       (lambda ()
	 (structure-walk (lambda (var value)
			   (format standard-output "  (%s %S)\n" var value))
			 (intern-structure
			  (repl-struct (fluid current-repl))))))

  (put 'exports 'repl-command
       (lambda ()
	 (print-list (structure-interface
		      (intern-structure
		       (repl-struct (fluid current-repl)))))))

  (put 'imports 'repl-command
       (lambda ()
	 (print-list (module-imports (repl-struct (fluid current-repl))))))

  (put 'accessible 'repl-command
       (lambda ()
	 (print-list (structure-accessible
		      (intern-structure
		       (repl-struct (fluid current-repl)))))))

  (put 'collect 'repl-command garbage-collect)

  (put 'dis 'repl-command
       (lambda (arg)
	 (require 'rep.vm.disassembler)
	 (disassemble (repl-eval arg))))
  (put 'dis 'repl-help "FORM")

  (put 'compile-proc 'repl-command
       (lambda args
	 (require 'rep.vm.compiler)
	 (mapc (lambda (arg)
		 (compile-function (repl-eval arg) arg)) args)))
  (put 'compile-proc 'repl-help "PROCEDURE ...")

  (put 'compile 'repl-command
       (lambda args
	 (require 'rep.vm.compiler)
	 (if (null args)
	     (compile-module (repl-struct (fluid current-repl)))
	   (mapc compile-module args))))
  (put 'compile 'repl-help "[STRUCT ...]")

  (put 'new 'repl-command
       (lambda (name)
	 (declare (bound %open-structures))
	 (make-structure nil (lambda ()
			       (%open-structures '(rep.module-system)))
			 nil name)
	 (repl-set-struct (fluid current-repl) name)))
  (put 'new 'repl-help "STRUCT")

  (put 'expand 'repl-command
       (lambda (form)
	 (format standard-output "%s\n" (repl-eval `(,macroexpand ',form)))))
  (put 'expand 'repl-help "FORM")

  (put 'step 'repl-command
       (lambda (form)
	 (format standard-output "%s\n" (repl-eval `(,step ',form)))))
  (put 'step 'repl-help "FORM")

  (put 'help 'repl-command
       (lambda ()
	 (write standard-output "
Either enter lisp forms to be evaluated, and their result printed, or
enter a meta-command prefixed by a `,' character.\n\n")
	 (print-list (sort (apropos "" (lambda (x)
					 (get x 'repl-command))))
		     (lambda (x)
		       (format nil ",%s %s" x (or (get x 'repl-help) ""))))))

  (put 'quit 'repl-command (lambda () (throw 'quit 0)))

  (put 'describe 'repl-command
       (lambda (name)
	 (require 'rep.lang.doc)
	 (let* ((value (repl-eval name))
		(struct (locate-binding* name))
		(doc (documentation name struct value)))
	   (write standard-output #\newline)
	   (describe-value value name struct)
	   (write standard-output #\newline)
	   (when doc
	     (format standard-output "%s\n\n" doc)))))
  (put 'describe 'repl-help "SYMBOL")

  (put 'apropos 'repl-command
       (lambda (re)
	 (require 'rep.lang.doc)
	 (let ((funs (apropos re (lambda (x)
				   (condition-case nil
				       (progn
					 (repl-eval x)
					 t)
				     (void-value nil))))))
	   (mapc (lambda (x)
		   (describe-value (repl-eval x) x)) funs))))
  (put 'apropos 'repl-help "\"REGEXP\"")

  (put 'locate 'repl-command
       (lambda (var)
	 (let ((struct (locate-binding* var)))
	   (if struct
	       (format standard-output "%s is bound in: %s.\n" var struct)
	     (format standard-output "%s is unbound.\n" var)))))
  (put 'locate 'repl-help "SYMBOL")

  (put 'whereis 'repl-command
       (lambda (var)
	 (let ((out '()))
	   (structure-walk (lambda (k v)
			     (when (and (structure-name v)
					(structure-exports-p v var))
			       (setq out (cons (structure-name v) out))))
			   (get-structure '%structures))
	   (if out
	       (format standard-output "%s is exported by: %s.\n"
		       var (mapconcat symbol-name (sort out) ", "))
	     (format standard-output "No module exports %s.\n" var)))))
  (put 'whereis 'repl-help "SYMBOL")

  (put 'time 'repl-command
       (lambda (form)
	 (let (t1 t2 ret)
	   (setq t1 (current-utime))
	   (setq ret (repl-eval form))
	   (setq t2 (current-utime))
	   (format standard-output
		   "%S\nElapsed: %d seconds\n" ret (/ (- t2 t1) 1e6)))))
  (put 'time 'repl-help "FORM")

  (put 'profile 'repl-command
       (lambda (form)
	 (require 'rep.lang.profiler)
	 (format standard-output "%S\n\n" (call-in-profiler
					   (lambda () (repl-eval form))))
	 (print-profile)))
  (put 'profile 'repl-help "FORM"))

#| debug.jl -- Lisp debugger (well, single-stepper anyway)

   $Id: debugger.jl,v 1.27 2000/09/10 20:03:17 john Exp $

   Copyright (C) 1993, 1994, 2000 John Harper <john@dcs.warwick.ac.uk>

   This file is part of Librep.

   Librep is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   Librep is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Librep; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|#

;; XXX extend this to support the structure inspection meta-commands
;; of the top-level repl

(define-structure rep.lang.debugger ()

    (open rep
	  rep.structures
	  rep.regexp
	  rep.io.readline)

;;; the form stopped on

  (define obj (make-fluid))
  (define depth (make-fluid))
  (define frame-pointer (make-fluid))

  (define last (make-fluid))

;;; the debugger repl

  (defun debug-rep ()
    (let
	((print-escape t))
      (when (fluid depth)
	(format standard-error "<%d> %S\n" (fluid depth) (fluid obj)))
      (while t
	(let
	    ((input (readline "rep-db? "))
	     next-last)
	  (cond ((string-match "^\\s*n" input)
		 (fluid-set last do-next)
		 (do-next))
		((string-match "^\\s*s" input)
		 (fluid-set last do-step)
		 (do-step))
		((string-match "^\\s*c" input)
		 (fluid-set last do-continue)
		 (do-continue))
		((string-match "^\\s*r\\w*\\s+" input)
		 (do-set-result
		  (eval (read-from-string (substring input (match-end))))))
		((string-match "^\\s*u" input)
		 (fluid-set last do-up)
		 (do-up))
		((string-match "^\\s*d" input)
		 (fluid-set last do-down)
		 (do-down))
		((string-match "^\\s*p\\w*\\s+" input)
		 (condition-case data
		     (format standard-error "%S\n"
			     (eval-in-frame
			      (read-from-string
			       (substring input (match-end)))))
		   (error (default-error-handler (car data) (cdr data)))))
		((string-match "^\\s*b" input)
		 (do-backtrace))
		((string-match "^\\s*f" input)
		 (format standard-error "<%d> %S\n" (fluid depth) (fluid obj)))
		((string-match "^\\s*l" input)
		 (print-locals))
		((string-match "^\\s*$" input)
		 (if (fluid last)
		     (progn
		       ((fluid last))
		       (setq next-last (fluid last)))
		   (write standard-error "Nothing to repeat\n")))
		(t
		 (write standard-error "\
commands: `n[ext]', `s[tep]', `c[ontinue]', `r[eturn] FORM',
          `p[rint] FORM', `b[acktrace]', `f[orm], `l[ocals]''\n")))
	  (fluid-set last next-last)))))

;;; local functions

  (defun print-locals ()
    (let
	;; (ENV . STRUCTURE)
	((data (debug-frame-environment (fluid frame-pointer))))
      (when data
	(mapc (lambda (cell)
		(format standard-error "%16s %S\n"
			(symbol-name (cadr cell)) (cddr cell)))
	      (car data)))))

  (defun eval-in-frame (form)
    (let
	;; (ENV . STRUCTURE)
	((data (debug-frame-environment (fluid frame-pointer))))
      (when data
	(eval form (cdr data) (car data)))))

  (defun entry (debug-obj debug-depth debug-frame-pointer)
    (catch 'debug
      (let-fluids ((obj debug-obj)
		   (depth debug-depth)
		   (frame-pointer debug-frame-pointer))
	(debug-rep))))

  (defun exit (debug-val debug-depth debug-frame-pointer)
    (format standard-error "<%d> => %S\n" debug-depth debug-val))

  (defun error-entry (error-list debug-frame-pointer)
    (default-error-handler (car error-list) (cdr error-list))
    (catch 'debug
      (let-fluids ((frame-pointer debug-frame-pointer))
	(debug-rep)
	nil)))

  (defun do-step ()
    (throw 'debug (cons 1 (fluid obj))))

  (defun do-set-result (value)
    (throw 'debug (cons 4 value)))

  (defun do-next ()
    (throw 'debug (cons 2 (fluid obj))))

  (defun do-continue ()
    (throw 'debug (cons 3 (fluid obj))))

  (defun do-backtrace ()
    (backtrace standard-output)
    (write standard-output #\newline))

  (defun do-up ()
    (when (fluid frame-pointer)
      (let ((fp (debug-inner-frame (fluid frame-pointer))))
	(when fp
	  (fluid-set frame-pointer fp)))))

  (defun do-down ()
    (when (fluid frame-pointer)
      (let ((fp (debug-outer-frame (fluid frame-pointer))))
	(when fp
	  (fluid-set frame-pointer fp)))))

;;; initialize debug hooks (special variables)

  (setq debug-entry entry)
  (setq debug-exit exit)
  (setq debug-error-entry error-entry))

#| rep.jl -- read-eval-print loop

   $Id: user.jl,v 1.7 2000/09/19 10:32:56 john Exp $

   Copyright (C) 1993, 1994 John Harper <john@dcs.warwick.ac.uk>

   This file is part of librep.

   librep is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   librep is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with librep; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|#

(define-structure user ()

    ((open rep
	   rep.regexp
	   rep.system
	   rep.io.files
	   rep.io.processes)
     (set-binds))

  (setq *user-structure* 'user)

  ;; Install all autoload hooks.
  (load-all "autoload" (lambda (f) (load f nil t)))

  ;; Do operating-system initialisation
  (load-all (concat "os-" (symbol-name operating-system)) t)
  
  ;; Load site specific initialisation. Errors here are trapped since
  ;; they're probably not going to result in an unusable state
  (unless (get-command-line-option "--no-rc")
    (condition-case error-data
	(progn
	  ;; First the site-wide stuff
	  (load-all "site-init")
	  ;; Now try to interpret the user's startup file, or failing that
	  ;; the default.jl file providing site-wide user options
	  (or
	   (load (concat (user-home-directory) ".reprc") t t t)
	   (load "rep-default" t)))
      (error
       (default-error-handler (car error-data) (cdr error-data)))))
  
  ;; Use all arguments which are left.
  (let
      ((do-load (lambda (name)
		  (cond ((file-exists-p name)
			 (load name nil t t))
			((string-match "\\.jlc?$" name)
			 (load name))
			(t (require (intern name))))))
       arg)
    (while (setq arg (car command-line-args))
      (setq command-line-args (cdr command-line-args))
      (cond
       ((member arg '("--call" "-f"))
	(setq arg (car command-line-args))
	(setq command-line-args (cdr command-line-args))
	((symbol-value (read-from-string arg))))
       ((member arg '("--load" "-l"))
	(setq arg (car command-line-args))
	(setq command-line-args (cdr command-line-args))
	(do-load arg))
       ((member arg '("-s" "--scheme"))
	(setq arg (car command-line-args))
	(setq command-line-args (cdr command-line-args))
	(setq batch-mode t)
	(if (file-exists-p arg)
	    (structure () (open scheme) (load arg '() 1 1))
	  (structure () (open scheme) (load arg))))
       ((string= arg "--help")
	(format standard-error "\
usage: %s [OPTIONS...]

where OPTIONS are any of:

    FILE		load the Lisp file FILE (from the cwd if possible,
			 implies --batch mode)

    --batch		batch mode: process options and exit
    --interp		interpreted mode: don't load compile Lisp files

    --call FUNCTION	call the Lisp function FUNCTION
    --f FUNCTION

    --load FILE		load the file of Lisp forms called FILE
    -l FILE

    --scheme FILE	load the file of Scheme forms called FILE
    -s FILE		 (implies --batch mode)

    --version		print version details
    --no-rc		don't load rc or site-init files
    --quit, -q		terminate the interpreter process\n" program-name)
	(throw 'quit 0))
       ((string= arg "--version")
	(format standard-output "rep version %s\n" rep-version)
	(throw 'quit 0))
       ((member arg '("--quit" "-q"))
	(throw 'quit 0))
       (t
	(setq batch-mode t)
	(do-load arg)))))

  (unless batch-mode
    (format standard-output "rep %s, Copyright (C) 1999-2000 John Harper
rep comes with ABSOLUTELY NO WARRANTY; for details see the file COPYING
Built %s\n" rep-version rep-build-id)

    (require 'rep.util.repl)
    (repl)))

;; prevent this being opened as a module
nil

#| quote-url.jl -- url-escape a given string

   $Id: quote-url.jl,v 1.3 2000/09/10 20:03:17 john Exp $

   Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

   This file is part of librep.

   librep is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   librep is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with librep; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|#

;; Background:

;; Sen Nagata posted code to do the escaping part of this to the rep
;; mailing list (<20000424174557J.1000@eccosys.com>). I've rewritten it
;; to use regexps, and added the decoder.

(define-structure rep.www.quote-url

    (export quote-url
	    unquote-url)

    (open rep
	  rep.regexp)

  (defconst url-meta-re "[^a-zA-Z0-9$_.!~*'(),-]"
    "A regexp matching a single character that is reserved in the URL spec.
This is taken from draft-fielding-url-syntax-02.txt -- check your local
internet drafts directory for a copy.")
       
  (define (quote-url string)
    "Escape URL meta-characters in STRING."
    (let loop ((point 0)
	       (out '()))
      (if (string-match url-meta-re string point)
	  (loop (match-end)
		(cons (string-upcase
		       (format nil "%%%02x" (aref string (match-start))))
		      (cons (substring string point (match-start)) out)))
	(if (null out)
	    string
	  (apply concat (nreverse (cons (substring string point) out)))))))

  (define (unquote-url string)
    "Unescape URL meta-characters in STRING."
    (let loop ((point 0)
	       (out '()))
      (if (string-match "%([0-9A-Fa-f][0-9A-Fa-f])" string point)
	  (loop (match-end)
		(cons (string->number (expand-last-match "\\1") 16)
		      (cons (substring string point (match-start)) out)))
	(if (null out)
	    string
	  (apply concat (nreverse (cons (substring string point) out))))))))

#| queues.jl -- fifo queues

   $Id: queues.jl,v 1.3 2000/07/23 22:24:33 john Exp $

   Copyright (C) 2000 John Harper <john@dcs.warwick.ac.uk>

   This file is part of librep.

   librep is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   librep is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with Jade; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|#

(define-structure rep.data.queues

    (export make-queue
	    enqueue
	    dequeue
	    queue-empty-p
	    queuep
	    queue->list
	    queue-length
	    delete-from-queue)

    (open rep
	  rep.data.datums)

  (define-structure-alias queues rep.data.queues)

  (define type-id (cons))

  (define-datum-printer type-id (lambda (q stream)
				  (write stream "#<queue>")))

  (define (make-queue)
    (make-datum '() type-id))

  (define (enqueue q x)
    (datum-set q type-id (nconc (datum-ref q type-id) (list x))))

  (define (dequeue q)
    (let ((data (datum-ref q type-id)))
      (if (null data)
	  (error "Can't dequeue from empty queue")
	(datum-set q type-id (cdr data))
	(car data))))

  (define (queue-empty-p q)
    (null (datum-ref q type-id)))

  (define (queuep q)
    (has-type-p q type-id))

  (define (queue->list q)
    (datum-ref q type-id))

  (define (queue-length q)
    (length (queue->list q)))

  (define (delete-from-queue q x)
    (datum-set q type-id (delq x (datum-ref q type-id)))))

( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf queues.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/data/queues.jl queues.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf queues.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/data/queues.jlc queues.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf records.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/data/records.jl records.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf records.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/data/records.jlc records.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf ring.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/data/ring.jl ring.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf ring.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/data/ring.jlc ring.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf symbol-table.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/data/symbol-table.jl symbol-table.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf symbol-table.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/data/symbol-table.jlc symbol-table.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf remote-ftp.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/io/file-handlers/remote/ftp.jl remote-ftp.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf remote-ftp.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/io/file-handlers/remote/ftp.jlc remote-ftp.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf remote-rep.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/io/file-handlers/remote/rep.jl remote-rep.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf remote-rep.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/io/file-handlers/remote/rep.jlc remote-rep.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf lisp-doc.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/lang/compat-doc.jl lisp-doc.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf lisp-doc.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/lang/compat-doc.jlc lisp-doc.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf mailaddr.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/mail/addr.jl mailaddr.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf mailaddr.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/mail/addr.jlc mailaddr.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf mutex.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/threads/mutex.jl mutex.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf mutex.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/threads/mutex.jlc mutex.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf date.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/util/date.jl date.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf date.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/util/date.jlc date.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf gaol.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/util/gaol.jl gaol.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf gaol.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/util/gaol.jlc gaol.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf memoize.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/util/memoize.jl memoize.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf memoize.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/util/memoize.jlc memoize.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf compiler.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/vm/compiler.jl compiler.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf compiler.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/vm/compiler.jlc compiler.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf disassembler.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/vm/disassembler.jl disassembler.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf disassembler.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/vm/disassembler.jlc disassembler.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf cgi-get.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/www/cgi-get.jl cgi-get.jl )
( cd opt/gnome/share/rep/0.13.6/lisp ; rm -rf cgi-get.jlc )
( cd opt/gnome/share/rep/0.13.6/lisp ; ln -sf rep/www/cgi-get.jlc cgi-get.jlc )
( cd opt/gnome/libexec/rep/0.13.6/sparc-slackware-linux-gnu ; rm -rf gettext.so )
( cd opt/gnome/libexec/rep/0.13.6/sparc-slackware-linux-gnu ; ln -sf rep/i18n/gettext.so gettext.so )
( cd opt/gnome/libexec/rep/0.13.6/sparc-slackware-linux-gnu ; rm -rf readline.so )
( cd opt/gnome/libexec/rep/0.13.6/sparc-slackware-linux-gnu ; ln -sf rep/io/readline.so readline.so )
( cd opt/gnome/libexec/rep/0.13.6/sparc-slackware-linux-gnu ; rm -rf gdbm.so )
( cd opt/gnome/libexec/rep/0.13.6/sparc-slackware-linux-gnu ; ln -sf rep/io/db/gdbm.so gdbm.so )
( cd opt/gnome/libexec/rep/0.13.6/sparc-slackware-linux-gnu ; rm -rf sdbm.so )
( cd opt/gnome/libexec/rep/0.13.6/sparc-slackware-linux-gnu ; ln -sf rep/io/db/sdbm.so sdbm.so )
( cd opt/gnome/libexec/rep/0.13.6/sparc-slackware-linux-gnu ; rm -rf tables.so )
( cd opt/gnome/libexec/rep/0.13.6/sparc-slackware-linux-gnu ; ln -sf rep/data/tables.so tables.so )
( cd opt/gnome/libexec/rep/0.13.6/sparc-slackware-linux-gnu ; rm -rf timers.so )
( cd opt/gnome/libexec/rep/0.13.6/sparc-slackware-linux-gnu ; ln -sf rep/io/timers.so timers.so )
( cd opt/gnome/lib ; rm -rf librep.so.9 )
( cd opt/gnome/lib ; ln -sf librep.so.9.1.5 librep.so.9 )
( cd opt/gnome/lib ; rm -rf librep.so )
( cd opt/gnome/lib ; ln -sf librep.so.9.1.5 librep.so )
